/* Rank and Percentile */

options results
if ~show('P','TCALC') then do
	address command 'run turbocalc:turbocalc'
	address command 'waitforport TCALC'
	loadflag=1
end
address 'TCALC'
'DEFPUBSCREEN()'
/* Add-in Rexx Math Library needed for some routines */
signal on syntax
if ~show('l','rexxmathlib.library') then
   call addlib('rexxmathlib.library',0,-30)
if ~show('l','rexxreqtools.library') then
   call addlib('rexxreqtools.library',0,-30)
if ~show('l','rexxsupport.library') then
   call addlib('rexxsupport.library',0,-30)
  /* add to library list */
signal off syntax

/* Start Main Routine */
if loadflag=1 then 'Load()'
'ActivateWindow()'
range=rtgetstring(,"Enter Cell Range for Input","Input Request") /*,,'rt_pubscrname="TCALC"')*/
colon=pos(":",range)
if colon=0 then do
	'Message "Please select a range before executing this script"'
	'DEFPUBSCREEN("Workbench")'
	exit
end

/* Find cell references and cell, column numbers */
start_cell=substr(range,1,colon-1)
end_cell=substr(range,colon+1)
start_row=cellrow(start_cell)
end_row=cellrow(end_cell)
start_col=cellcol(start_cell)
end_col=cellcol(end_cell)
NRows=end_row-start_row+1
NCols=end_col-start_col+1

/* Get cell reference for output range */
out_cell=rtgetstring(,"Enter Cell Reference for Output","Input Request") /*,,'rt_pubscrname="TCALC"')*/
if out_cell="" then do
	'DEFPUBSCREEN("Workbench")'
	exit
end
if length(out_cell)<2 | datatype(left(out_cell,1),'n') then do
	'Message "Invalid cell reference"'
	'DEFPUBSCREEN("Workbench")'
	exit
end
/* Suppress Screen Redraw to Speed Things Up */
'Refresh 0'

/* Open a small output window on tcalc screen*/
fo=0
CR='0a'x
DisplayMsg="Calculating...Please Wait."||CR||"User input is disabled during calculation."||CR
if open(6Info, 'con:100/0/450/80/Progress/SCREEN TCALC', w) then do
	 call writeln(6Info, DisplayMsg)
	fo=1
end
else do
	'Message "TCALC Screen not available for Progress messages"'
end
CALL DELAY(150)

/* Get cell references for top cell in each column */
'SelectCell' start_cell
do col=start_col to end_col
	'GetCursorPos'
	top_cell.col=result
	'Column 1'
end

/* Get labels for later use on output */
'SelectCell' start_cell
'GetValue'
testlabel=result
testlabel=strip(testlabel)
if datatype(testlabel,'n')=1 then do
	labelflag=0
	do x=1 to NCols
	title.x="Column "||x
	end
end
else do
	labelflag=1
	NRows=NRows-1
	do x=1 to NCols
	'GetValue'
	str=result
	title.x=translate(strip(str),"_"," ")
	'Column 1'
	end
end
if fo then call writech(6Info,"Progress...10 ")

/* Get data from cell range */
col=start_col
lav=0
tot=0
count.=0
total.=0
do x=1 to NCols
	'SelectCell' top_cell.col
	if labelflag=1 then 'CursorDown 1'
	do y=1 to NRows
		'GetValue'
		valtest=result
		if datatype(valtest)='NUM' then do
			'GetValue'
			val=result
			data.x.y=val
			tot=tot+val
			total.x=tot
			count.x=1+count.x
		end
		'CursorDown 1'
	end
	col=col+1
	tot=0
	lav=0
	val=0
end
if fo then call writech(6Info,"20 ")

/* Sort Values */
call Sort()
if fo then call writech(6Info,"40 ")

/* Calculate Rank and Percentile Rank and Percentile Points */

Ppoint.=0
PRank.=0
Rank.=0
Do x=1 to NCols
	N=count.x
	Span=100/(N-1)
	PH=((1/N)*100)/2
	Do y=1 to NRows
	z=y+1
	if data.x.y=data.x.z then do
		cnt=1
		beginrank=y
		avrank=y
		endrank=0
		do until endrank~=0
			y=y+1
			avrank=avrank+y
			z=y+1
			cnt=cnt+1
			if data.x.y~=data.x.z then endrank=y
		end
		avrank=avrank/cnt
		do y=beginrank to endrank
			PRank.x.y=nint(100*((avrank-.5)/N))
			Rank.x.y=N-trunc(avrank)
			Ppoint.x.y=100-(Span*((Rank.x.y)-1))-Span
			if (Ppoint.x.y) < 0 then (Ppoint.x.y) == 0
		end
	y=y-1
	end
	else do
		PRank.x.y=nint(100*((y-.5)/N))
		Rank.x.y=N-y+1
		Ppoint.x.y=100-(Span*((Rank.x.y)-1))
		if (Ppoint.x.y) < 0 then (Ppoint.x.y) == 0
	end
	end
end
if fo then do
	call writeln(6Info,"100")
	call writeln(6Info,"Writing output to window...")
end
/* Output */
'SelectCell' out_cell
Do x=1 to NCols
	'GetCursorPos'
	cell.x=result
	title=""""||title.x||""""
	'Alignment 2'
	'Put' title
	'Column 1'
	'GetCursorPos'
	rankcell.x=result
	'Alignment 2'
	'Put' "Rank"
	'Column 1'
	'GetCursorPos'
	percentcell.x=result
	'Alignment 2'
	'Put' "Percentile"
	'CursorDown 1'
	'Alignment 2'
	'Put' "Rank"
	'CursorUp 1'
	'Column 1'
	'GetCursorPos'
	pointcell.x=result
	'Alignment 2'
	'Put' "Percentile"
	'CursorDown 1'
	'Alignment 2'
	'Put' "Point"
	'CursorUp 1'
	'Column 1'
end
Do x=1 to NCols
	'SelectCell' cell.x
	'CursorDown 2'
	do y=1 to NRows
		'Put' data.x.y
		'CursorDown 1'
	end
	'SelectCell' rankcell.x
	'CursorDown 2'
	do y=1 to NRows
		'Put' Rank.x.y
		'CursorDown 1'
	end
	'SelectCell' percentcell.x
	'CursorDown 2'
	do y=1 to NRows
		'Put' PRank.x.y
		'CursorDown 1'
	end
	'SelectCell' pointcell.x
	'CursorDown 2'
	do y=1 to NRows
		'NumericFormat 2'
		'Put' Ppoint.x.y
		'CursorDown 1'
	end
end

'Refresh 1'
'Refresh 2'
/*'Message' "Finished"*/
/*indicate the main script is finished*/
DisplayMsg="Cleaning up ...."||CR||"Exiting"
result=writeln(6Info, DisplayMsg)
if result~=0 then do
	/*Wait 3 seconds*/
	CALL DELAY(150)
	/* close window*/
	result=close(6Info)
end
'DEFPUBSCREEN("Workbench")'
exit

/* Procedures */

cellrow: procedure
do
	parse arg cell
	do charpos=2 to length(cell)
	if datatype(substr(cell,charpos,1),n) then return substr(cell,charpos)
	end
	return 0
end
Return

cellcol: procedure
do
	parse arg cell
	labels="ABCDEFGHIJKLMNOPQRSTUVWXYZ"
	cell=upper(cell)
	len=length(cell)
	val=0
do charpos=1 to len
	if datatype(substr(cell,charpos,1),n) then
	do cell=reverse(substr(cell,1,charpos-1))
	do x=1 to length(cell)
	val=(26**(x-1))*pos(substr(cell,x,1),labels)+val
	end
	return val
	end
	end
	return 0
end
Return
/* It is important to put the exposed array at the end of the next line */
Sort: procedure expose NCols NRows data.
do x=1 to NCols
L=(xtoy(2,int(log(NRows)/log(2))))-1
	Do Until L<1
	L=trunc(int(L/2))
	Do J=1 to L
			Do K=J+L To NRows By L
			I=K
			dumdat=data.x.I
			Do while I>L
				y=I-L
				If data.x.y ~> dumdat then Leave
				data.x.I=data.x.y
				I=I-L
			End
			data.x.I=dumdat
			End
		End
	End
End
Return

syntax:
	 if arg(1)='FAIL' then do
	    'Message "Library is unavailable."'
		'DEFPUBSCREEN("Workbench")'
	    exit
	    end
	'DEFPUBSCREEN("Workbench")'
	exit